function [fbest sol x mem v]=PSO(objFcnHandle,xinit,varargin)

    %Initialization
    dimension=length(xinit);
    popsize=max(length(xinit),5);
    x=zeros(popsize,dimension+1);
    for i=1:1:dimension
        x(:,i)=randn(popsize,1);
    end
    for i=1:popsize
      x(i,dimension+1) = objFcnHandle(x(i,1:dimension),varargin{:});
    end
    mem=x;
    v=zeros(popsize,dimension+1);
    
    if(popsize ~= 1)
      topology=zeros(popsize,popsize);
      for i=1:popsize
	  if(i==1)
	      topology(i,popsize)=1;
	      topology(i,i+1)=1;
	  else if(i==popsize)
	      topology(i,1)=1;
	      topology(i,i-1)=1;
	  else
	      topology(i,i+1)=1;
	      topology(i,i-1)=1;
	  end
	  end
      end
    else
       topology=ones(popsize,popsize);
    end
    
    chi=0.729;
    ca=2.05;
    sa=2.05;
    maxiter=100*dimension;
    
    %Main loop
    
    iter = 0;
    while iter < maxiter || norm(v(:,1:dimension)) > 1e-3 
         
         for i=1:popsize
           bestneighbor = find(mem(:,dimension+1)==min(mem(find(topology(i,:)),dimension+1)));
	   for j=1:dimension
	      v(i,j) = chi*(v(i,j) + ca*rand(1,1)*(mem(i,j)-x(i,j)) + sa*rand(1,1)*(mem(bestneighbor,j)-x(i,j)));
	   end
         end
         
         for i=1:popsize
           x(i,:) = x(i,:)+v(i,:);
         end
        
	 for i=1:popsize
	  x(i,dimension+1) = objFcnHandle(x(i,1:dimension),varargin{:});	  
	  if(x(i,dimension+1) < mem(i,dimension+1))
	    mem(i,:)=x(i,:);
	  end
	 end
         
        iter=iter+1;
    end
    bestparticle=find(mem(:,dimension+1)==min(mem(:,dimension+1)));
    sol = mem(bestparticle,1:dimension);
    fbest = mem(bestparticle,dimension+1);
end